#!BPY

""" Registration info for Blender menus: <- these words are ignored
Name: 'IPO Modify Frames'
Blender: 242
Group: 'Animation'
Tip: 'IPO Expand / Reduce / Step / Reverse / Eater'
"""

__author__ = "Keines"
__url__ = ("blender", "elysiun", "My HomePage, http://keines.gozaru.jp/blender/index.html")
__version__ = "2007.01.30(Tue) 00:31"

__bpydoc__ = """\
How to ..

Expand / Reduce
  1 Input Number StartFrame , EndFrame
  2 Select Object
  3 Execute

Step
  1 Input StartFrame
  2 Select Object
  3 Execute

Reverse
  1 Select Object
  2 Execute

Eater
  1 Input Step
  2 Select Object
  3 Execute

Notice: Eater is a dangerous ... at Your Own Risk ...
"""

import Blender,re
from Blender import Draw, BGL,Object,Ipo,Window

# --- User Config ---------------
ModifyKey='LOC|ROT'
ModifyCurve=re.compile(ModifyKey,re.IGNORECASE)
# -------------------------------

Title		= 'IPO Modify Frames'
Version		= 'ver.2007.01.30(Tue) 00:31'
Author		= ' by keines'
VerWidth	= Draw.GetStringWidth(Version+Author)

# + BaseValue
SpcWidth	= 20
BaseHeight	= 20
BtnHeight	= 20
FrameRange	= 1000.00   # Min=-1000.00,Max=1000.00

LabelColon	= ' : '

# + Label Menu
MenuLabel	= ['Expand / Reduce',' - Step',' - Reverse',' - Eater']
MenuLabel_Expand= 0
MenuLabel_Step  = 1
MenuLabel_Reverse=2
MenuLabel_Eater = 3

MenuBtn=Draw.Create(MenuLabel_Expand+1)

MenuBtnStr = "Select Menu %t|"
for i in range(len(MenuLabel)):
  MenuBtnStr += MenuLabel[i]+" %x"+str(i+1)+"|"

# + Label Main
MainLabel	= [['Xmin',0],['Xmax',0],['Step',0],['Execute',0],['Exit',0]]
MainLabel_Xmin	= 0
MainLabel_Xmax	= 1
MainLabel_Step	= 2
MainLabel_Execute=3
MainLabel_Exit	= 4

#   - vZ
for i in range(len(MainLabel)):
    MainLabel[i][1]=Draw.GetStringWidth(MainLabel[i][0])+SpcWidth

MenuBtnWidth = Draw.GetStringWidth(MenuLabel[MenuLabel_Expand]+'  ')+SpcWidth
NumberBtnWidth = Draw.GetStringWidth(str(FrameRange)+LabelColon)+MainLabel[MainLabel_Xmin][1]+SpcWidth

#   - KvȉɌvZĂ
i=2*(NumberBtnWidth)
MaxWidth=MenuBtnWidth+MainLabel[MainLabel_Execute][1]
if i>MaxWidth:
  MaxWidth=i+6
  MainLabel[MainLabel_Execute][1]=i-MenuBtnWidth
if VerWidth>MaxWidth:
  MaxWidth=VerWidth

# + Button
#   - Step
BtnStep = [Draw.Create(1.0),Draw.Create(1.0)]
BtnStep_Xmin=0
BtnStep_Step =1

#   - Expand
BtnExpand=[[Draw.Create(float(1))                       , MainLabel[MainLabel_Xmin][0]+LabelColon],
           [Draw.Create(float(Blender.Get('endframe'))) , MainLabel[MainLabel_Xmax][0]+LabelColon]]
BtnExpand_Start= 0 # Number
BtnExpand_End = 1

#   - Eater
BtnEater=[[Draw.Create(2) , MainLabel[MainLabel_Step][0]+LabelColon]]
BtnEater_Step = 0 # Number

# + Event
Event_None	= 0
Event_Menu	= 1
Event_Execute	= 2
Event_Exit	= 3

def DrawGui():
    global MenuBtn,BtnList,BtnStep,MaxWidth
    
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size= size.list
    # FLOAT -> INT
    for s in range(4): size[s]=int(size[s])
    # Base Position
    x=20
    y=size[3]-BaseHeight
    # + Title
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title)
    
    # --- GUI ---
    y-=BaseHeight*2
    # + Menu
    #menuName = "Select Menu %t|"+MenuLabel[0]+" %x1|"+MenuLabel[1]+" %x2|"+MenuLabel[2]+" %x3|"+MenuLabel[3]+" %x4"
    MenuBtn = Draw.Menu(MenuBtnStr,Event_Menu,x,y,MenuBtnWidth,BtnHeight,MenuBtn.val)
    # + Btn Execute
    Draw.Button (MainLabel[MainLabel_Execute][0],Event_Execute,x+MenuBtnWidth+6,y,MainLabel[MainLabel_Execute][1],BaseHeight,"")
    # + Btn Etc
    y-=BaseHeight+6+10
    MenuIdx=MenuBtn.val-1
    if MenuIdx==MenuLabel_Expand:
      # Expand / Reduce
      for i in [0,1]:
        BtnExpand[i][0]=Draw.Number(MainLabel[i][0],Event_None,x+i*(NumberBtnWidth+6),y,NumberBtnWidth, BtnHeight, float(BtnExpand[i][0].val), -FrameRange, FrameRange)
    elif MenuIdx==MenuLabel_Step:
      # Step
      BtnStep[BtnStep_Xmin]=Draw.Number(MainLabel[MainLabel_Xmin][0],Event_None,x,y,NumberBtnWidth, BtnHeight, BtnStep[BtnStep_Xmin].val, -FrameRange, FrameRange)
      BtnStep[BtnStep_Step] =Draw.Number(MainLabel[MainLabel_Step][0],Event_None,x+(NumberBtnWidth+6),y,NumberBtnWidth, BtnHeight, BtnStep[BtnStep_Step].val, -FrameRange, FrameRange)
    #elif MenuIdx==MenuIdx_Reverse:
    #  print "Reverse"
    elif MenuIdx==MenuLabel_Eater:
      # Eater
      BtnEater[BtnEater_Step][0]=Draw.Number(MainLabel[MainLabel_Step][0],Event_None,x,y,NumberBtnWidth, BtnHeight, BtnEater[BtnEater_Step][0].val, 2, FrameRange)
    # + Version
    y-=BaseHeight+6+10
    BGL.glRasterPos2f(x+MaxWidth-VerWidth, y)
    Draw.Text(Version+Author)
    # + Exit Button
    y-=BaseHeight+10
    Draw.Button (MainLabel[MainLabel_Exit][0],Event_Exit,x,y,MainLabel[MainLabel_Exit][1]+SpcWidth,BaseHeight,"")

# {^Cxg
def ButtonEvent(evt):
    if (evt==Event_Exit)		: Draw.Exit()
    elif (evt==Event_Menu)		: Draw.Register(DrawGui, KeyEvent, ButtonEvent)
    elif (evt==Event_Execute)		:
      Blender.Window.DrawProgressBar(0, '')
      
      MenuIdx=MenuBtn.val-1
      if MenuIdx==MenuLabel_Eater	: EaterFrames()
      elif MenuIdx==MenuLabel_Reverse	: ReverseFrames()
      elif MenuIdx==MenuLabel_Step	: StepFrames()
      elif MenuIdx==MenuLabel_Expand	: ExpandFrames()
      
      Blender.Window.DrawProgressBar(1, '')
      Blender.Window.RedrawAll()

# L[Cxg
def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) :
        return
    if evt in [Draw.ESCKEY, Draw.QKEY]:
        Draw.Exit()

# gAk
def ExpandFrames():
  try:
    Xmin=BtnExpand[BtnExpand_Start][0].val
    Xmax=BtnExpand[BtnExpand_End][0].val
    
    obList=Blender.Object.GetSelected()
    # + Loop: Object
    if obList!=None:
      cnt=len(obList)
      for i in range(cnt):
        IpoList=obList[i].getIpo()
        if IpoList!=None:
          Blender.Window.DrawProgressBar(float(i)/cnt, obList[i].name)
	  # + Loop: Curve
          for Curve in IpoList:
	    if ModifyCurve.search(Curve.name)==None:continue
            StartTime,StartValue = Curve.bezierPoints[0].pt
            EndTime  ,EndValue   = Curve.bezierPoints[-1].pt
            SrcWidth=abs(float(StartTime)-float(EndTime))	# \[Ẍ
            DstWidth=abs(Xmax-Xmin)				# [U[ẅ̗
	    # + Loop: Point
            for bz in Curve.bezierPoints:			# range  0..len
    	      SrcPerX=float(bz.pt[0]-StartTime)/float(SrcWidth)	# \[Ẍ悩 X ʒů߂
    	      UsrPosX=Xmin+float(SrcPerX)*float(DstWidth)	# [U[ẅ̗ł X ߂
    	      bz.pt=UsrPosX,bz.pt[1]				# 
            Blender.Ipo.Recalc(Curve)				# ꂪdv
  except  :
    Draw.PupMenu('err:ExpandFrames')

# Xebvt[
def StepFrames():
  try:
    obList=Blender.Object.GetSelected()
    if obList!=None:
      # + Loop: Object
      cnt=len(obList)
      startFrame=BtnStep[BtnStep_Xmin].val
      step=BtnStep[BtnStep_Step].val
      for i in range(cnt):				# IuWFNg
        IpoList=obList[i].getIpo()			# IPO
        if IpoList!=None:
          Blender.Window.DrawProgressBar(float(i)/cnt, obList[i].name)
          # + Loop: Curve
	  for Curve in IpoList:
	    if ModifyCurve.search(Curve.name)==None:continue
	    # + Loop: Point
	    k=0
            for bz in Curve.bezierPoints:
	      bz.pt=startFrame+k*step,bz.pt[1]
	      k+=1
            Blender.Ipo.Recalc(Curve)
  except  :
    Draw.PupMenu('err:StepFrames')

# t]:
# See Also: http://jmsoler.free.fr/didacticiel/blender/tutor/cpl_inverse_ipo.htm
def ReverseFrames():
  try:
    obList=Blender.Object.GetSelected()
    if obList!=None:
      # + Loop: Object
      cnt=len(obList)
      for i in range(cnt):				# IuWFNg
        IpoList=obList[i].getIpo()			# IPO
        if IpoList!=None:
          Blender.Window.DrawProgressBar(float(i)/cnt, obList[i].name)
          # + Loop: Curve
	  for Curve in IpoList:
	    if ModifyCurve.search(Curve.name)==None:continue
	    # + Reverse Point
	    First=Curve.bezierPoints[0].pt[0]
	    Last=Curve.bezierPoints[-1].pt[0]
	    pt=[]
	    for bz in Curve.bezierPoints:
	      pt.append(bz.pt[:])
	    pt.reverse()
	    # + Loop: Point
	    k=0
	    for bz in Curve.bezierPoints:
	      bz.pt=First+(Last-pt[k][0]),pt[k][1]
	      k+=1
	    Blender.Ipo.Recalc(Curve)
  except  :
    Draw.PupMenu('err:ReverseFrames')

# IPO J[u|CgXebvɍ폜
#   2007.01.28(Sun) 23:02 ʂɏƗ闦
def EaterFrames():
  try:
    CurveDic={}
    
    Step=BtnEater[BtnEater_Step][0].val
    obList=Blender.Object.GetSelected()
    if obList!=None:
      # + Loop: Object
      cnt=len(obList)
      for o in range(cnt):
        i=obList[o].getIpo()
        if i!=None:
          # + Collect ConstKeyCurve
          CurveNameList=[k.name for k in i if ModifyCurve.search(k.name)!=None]
          ConstKeys=[]
          for Name in CurveNameList:
	    if CurveDic.has_key(Name):			# 擾
	      ConstKeys.append(CurveDic[Name])
	    else:
    	      for ConstName in i.curveConsts.keys():	# RXg OB_LOCX,OB_LOCY.. o
    	        if ConstName.find('OB_'+Name.upper())!=-1:#
		  CurveDic[Name]=ConstName		# ɒǉ
    	          ConstKeys.append(ConstName)		#
		  break
          # + Loop: Curve
          Blender.Window.DrawProgressBar(float(o)/cnt, obList[o].name)
	  Curves=[]
          for cs in ConstKeys:
            Curve = eval("i[Ipo.%s]"%cs)		# J[u擾
            nm=Curve.name
            
            #NewPoints = Curve.bezierPoints[0:-1:Step]	# XgRs[
	    NewPoints=[]
	    for j in range(0,len(Curve.bezierPoints),Step):
	      NewPoints.append(Curve.bezierPoints[j].pt)
            exec("i[Ipo.%s]=None"%cs)			# 폜 : eval ł łȂ
            #
            i.addCurve(nm)				# J[u̒ǉ
            NewCurve = eval("i[Ipo.%s]"%cs)		# J[u擾
            for bz in NewPoints:			# icu.bezierPoints  ReadOnly 璼ڑoȂ
              NewCurve[bz[0]] = bz[1]			#
            #Blender.Ipo.Recalc(Curve)			# ̃^C~OłƃG[N₷
	    Curves.append(Curve)
	  # ܂Ƃ߂čČvZ
	  for Curve in Curves:
	    Blender.Ipo.Recalc(Curve)
  except  :
    Draw.PupMenu('err:EaterFrames')

Draw.Register(DrawGui, KeyEvent, ButtonEvent)
